﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace VitaminCtrlSample
{
    public partial class Form1 : Form
    {
        public bool _bConnected = false;
        public int _nFishEyeCtrlSpeed = 0;
        public int _nSnapshotFormat = 0;
        public bool _bRecording = false;
                
        

        public Form1()
        {
            InitializeComponent();

            // Init status
            ComboViewStream.SelectedIndex = 0;
            ComboProtocol.SelectedIndex = 1;
            ComboMountType.SelectedIndex = 0;
            ComboPresentMode.SelectedIndex = 0;
            ComboCtrlSpeed.SelectedIndex = 5;
            comboSnapshotFmt.SelectedIndex = 0;

            ButtonEnalbe(false);

            FisheyeEnableChk.Checked = true;
            StretchFSChk.Checked = true;
        }

        public void InitFisheyeSetting()
        {
            if (FisheyeEnableChk.Checked != true)
            {
                axVitaminCtrl1.EnableFishEye = false;
                return;
            }

            axVitaminCtrl1.EnableFishEye = true;
            axVitaminCtrl1.FishEyeMountType = (VITAMINDECODERLib.EFishEyeMountType) ComboMountType.SelectedIndex.GetHashCode();
            axVitaminCtrl1.ChangePresentMode = (VITAMINDECODERLib.EFishEyePresentMode)ComboPresentMode.SelectedIndex.GetHashCode() + 1;
            axVitaminCtrl1.FishEyeAspectRatioWidth = Convert.ToInt32(AspectRatioWTxt.Text);
            axVitaminCtrl1.FishEyeAspectRatioHeight = Convert.ToInt32(AspectRatioHTxt.Text);
        }

        private void Connect_Click(object sender, EventArgs e)
        {
            // fish eye setting
            InitFisheyeSetting();
                        
            // URL
            string strPreIP = "http://";
            
            if (IPTxt.TextLength != 0)
                axVitaminCtrl1.Url = strPreIP + IPTxt.Text;

            // Port
            axVitaminCtrl1.HttpPort = Convert.ToInt32(PortTxt.Text);

            // User name
            if (UserNameTxt.TextLength != 0)
                axVitaminCtrl1.UserName = UserNameTxt.Text;

            // Password
            if (PasswordTxt.TextLength != 0)
                axVitaminCtrl1.Password = PasswordTxt.Text;

            // View stream
            axVitaminCtrl1.ViewStream = (VITAMINDECODERLib.EDualStreamOption) ComboViewStream.SelectedIndex.GetHashCode();

            // Protocol
            axVitaminCtrl1.ConnectionProtocol = (VITAMINDECODERLib.EConnProtocol) ComboProtocol.SelectedIndex.GetHashCode() + 1;

            axVitaminCtrl1.Connect();

            
        }

        private void Disconnect_Click(object sender, EventArgs e)
        {
            axVitaminCtrl1.Disconnect();

            // Restore status
            CodecChkJpeg.Checked = false;
            CodecChkMpeg4.Checked = false;
            CodecChkH264.Checked = false;
            _bConnected = false;

            ButtonEnalbe(false);
        }

        // VitaminCtrl event handle
        private void axVitaminCtrl1_OnVideoCodec(object sender, AxVITAMINDECODERLib._IVitaminCtrlEvents_OnVideoCodecEvent e)
        {
            if (e.eVideoCodec == VITAMINDECODERLib.EVideoCodecType.eViCodecMJpeg)
            {
                CodecChkJpeg.Checked = true;
            }
            else if (e.eVideoCodec == VITAMINDECODERLib.EVideoCodecType.eViCodecSP)
            {
                CodecChkMpeg4.Checked = true;
            }
            else if (e.eVideoCodec == VITAMINDECODERLib.EVideoCodecType.eViCodecH264)
            {
                CodecChkH264.Checked = true;
            }
        }

        private void axVitaminCtrl1_OnConnectionOK(object sender, AxVITAMINDECODERLib._IVitaminCtrlEvents_OnConnectionOKEvent e)
        {
            _bConnected = true;
            ButtonEnalbe(true); 
        }

        private void axVitaminCtrl1_OnFishEyePreset(object sender, AxVITAMINDECODERLib._IVitaminCtrlEvents_OnFishEyePresetEvent e)
        {
            string strPresetInfo = "X : " + e.lX + ", Y : " + e.lY + ", Z : " + e.lZ + ", Z facotr : " + e.lZFactor + ", Scroll : " + e.lScroll + "\r\n";
            CurPresetInfo.AppendText(strPresetInfo);
        }

        // Form event handle
        private void ViewStreamCombo_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (_bConnected)
            {
                _bConnected = false;
                axVitaminCtrl1.ViewStream = (VITAMINDECODERLib.EDualStreamOption) ((System.Windows.Forms.ComboBox)sender).SelectedIndex.GetHashCode();
            }
        }

        private void ComboMountType_SelectedIndexChanged(object sender, EventArgs e)
        {
            axVitaminCtrl1.FishEyeMountType = (VITAMINDECODERLib.EFishEyeMountType) ((System.Windows.Forms.ComboBox)sender).SelectedIndex.GetHashCode();
        }

        private void ComboPresentMode_SelectedIndexChanged(object sender, EventArgs e)
        {
            axVitaminCtrl1.ChangePresentMode = (VITAMINDECODERLib.EFishEyePresentMode)((System.Windows.Forms.ComboBox)sender).SelectedIndex.GetHashCode() + 1;
        }

        private void ComboCtrlSpeed_SelectedIndexChanged(object sender, EventArgs e)
        {
            _nFishEyeCtrlSpeed = ((System.Windows.Forms.ComboBox)sender).SelectedIndex.GetHashCode();
        }

        private void StretchFSChk_CheckedChanged(object sender, EventArgs e)
        {
            axVitaminCtrl1.StretchFullScreen = StretchFSChk.Checked;
        }

        private void comboSnapshotFmt_SelectedIndexChanged(object sender, EventArgs e)
        {
            _nSnapshotFormat = ((System.Windows.Forms.ComboBox)sender).SelectedIndex.GetHashCode() + 1;
        }

        // full screen
        private void BtnFullScreen_Click(object sender, EventArgs e)
        {
            if (_bConnected)
            {
                axVitaminCtrl1.SetFullScreen(true);
            }
        }

        // Fish eye control
        private void FishEyeCtrl(VITAMINDECODERLib.EFishEyeControl eFECtrlType, string strMove, int nSpeed)
        {
            axVitaminCtrl1.FishEyeCtrl(eFECtrlType, strMove, nSpeed);
        }

        // Pan
        private void BtnPanLeft_Click(object sender, EventArgs e)
        {
            FishEyeCtrl(VITAMINDECODERLib.EFishEyeControl.eFishEyeCtrlPan, ((System.Windows.Forms.Button)sender).Text, _nFishEyeCtrlSpeed);
        }

        private void BtnPanRight_Click(object sender, EventArgs e)
        {
            FishEyeCtrl(VITAMINDECODERLib.EFishEyeControl.eFishEyeCtrlPan, ((System.Windows.Forms.Button)sender).Text, _nFishEyeCtrlSpeed);
        }

        // Tilt
        private void BtnTiltUp_Click(object sender, EventArgs e)
        {
            FishEyeCtrl(VITAMINDECODERLib.EFishEyeControl.eFishEyeCtrlTilt, ((System.Windows.Forms.Button)sender).Text, _nFishEyeCtrlSpeed);
        }

        private void BtnTiltDown_Click(object sender, EventArgs e)
        {
            FishEyeCtrl(VITAMINDECODERLib.EFishEyeControl.eFishEyeCtrlTilt, ((System.Windows.Forms.Button)sender).Text, _nFishEyeCtrlSpeed);
        }

        // Zoom
        private void BtnZoomIn_Click(object sender, EventArgs e)
        {
            FishEyeCtrl(VITAMINDECODERLib.EFishEyeControl.eFishEyeCtrlZoom, ((System.Windows.Forms.Button)sender).Text, _nFishEyeCtrlSpeed);
        }

        private void BtnZoomOut_Click(object sender, EventArgs e)
        {
            FishEyeCtrl(VITAMINDECODERLib.EFishEyeControl.eFishEyeCtrlZoom, ((System.Windows.Forms.Button)sender).Text, _nFishEyeCtrlSpeed);
        }

        // AutoPan
        private void BtnAutoPanStart_Click(object sender, EventArgs e)
        {
            FishEyeCtrl(VITAMINDECODERLib.EFishEyeControl.eFishEyeCtrlAutoPan, ((System.Windows.Forms.Button)sender).Text, _nFishEyeCtrlSpeed);
        }

        private void BtnAutoPanStop_Click(object sender, EventArgs e)
        {
            FishEyeCtrl(VITAMINDECODERLib.EFishEyeControl.eFishEyeCtrlAutoPan, ((System.Windows.Forms.Button)sender).Text, 0);
        }

        // Rotate
        private void BtnRotateStart_Click(object sender, EventArgs e)
        {
            FishEyeCtrl(VITAMINDECODERLib.EFishEyeControl.eFishEyeCtrlRotate, ((System.Windows.Forms.Button)sender).Text, _nFishEyeCtrlSpeed);
        }

        private void BtnRotateStop_Click(object sender, EventArgs e)
        {
            FishEyeCtrl(VITAMINDECODERLib.EFishEyeControl.eFishEyeCtrlRotate, ((System.Windows.Forms.Button)sender).Text, 0);
        }

        // Home
        private void BtnHome_Click(object sender, EventArgs e)
        {
            FishEyeCtrl(VITAMINDECODERLib.EFishEyeControl.eFishEyeCtrlHome, "", 0);
        }

        // Insert preset information sample to list
        private void BtnPresetInsert_Click(object sender, EventArgs e)
        {
            axVitaminCtrl1.FishEyeAddPresetInfoToList(45, 0, 50, 0, 0);
            axVitaminCtrl1.FishEyeAddPresetInfoToList(55, 0, 120, -20, 0);
            axVitaminCtrl1.FishEyeAddPresetInfoToList(35, 0, 110, 30, 0);
            axVitaminCtrl1.FishEyeAddPresetInfoToList(25, 0, -123, 0, 0);
            axVitaminCtrl1.FishEyeAddPresetInfoToList(11, 0, 35, 5, 0);
            axVitaminCtrl1.FishEyeAddPresetInfoToList(45, 0, -20, 0, 0);
        }

        // Clear all element in preset list
        private void BtnPresetRemove_Click(object sender, EventArgs e)
        {
            axVitaminCtrl1.FishEyeResetPresetList();
        }

        // Go to preset
        private void BtnGoPreset_Click(object sender, EventArgs e)
        {
            axVitaminCtrl1.FishEyeGoPreset(Convert.ToInt32(PresetTxtX.Text), Convert.ToInt32(PresetTxtY.Text), 
                Convert.ToInt32(PresetTxtZ.Text), Convert.ToInt32(PresetTxtZFactor.Text), Convert.ToInt32(PresetTxtScroll.Text));
        }

        // Get current preset info
        private void GetCurPresetInfo_Click(object sender, EventArgs e)
        {
            CurPresetInfo.AppendText("=================================\r\n");
            axVitaminCtrl1.FishEyeGetPresetInfo();
        }

        private void BtnClearStatus_Click(object sender, EventArgs e)
        {
            CurPresetInfo.Clear();
        }

        // Snapshot
        private void BtnSnapshotSave_Click(object sender, EventArgs e)
        {
            string FilePath = "";
            FileDialog saver = new SaveFileDialog();

            // Available file extensions
            saver.Filter = "All files (*.*)|*.*|*.jpg|*.jpg|*.bmp|*.bmp";

            // Adds a extension if the user does not
            saver.AddExtension = true;

            // Restores the selected directory, next time
            saver.RestoreDirectory = true;

            // Default directory
            saver.InitialDirectory = "c:\\";
            
            // Default file name
            saver.FileName = "FishEyeSanpshot";

            DialogResult result = saver.ShowDialog();

            if (result == DialogResult.OK)
            {
                FilePath = saver.FileName;

                if (FilePath.Length != 0)
                {
                    axVitaminCtrl1.SaveSnapshot((VITAMINDECODERLib.EPictureFormat)_nSnapshotFormat, FilePath);
                }
            }           
        }

        // Set viewer display ratio
        private void BtnSetAspectRatio_Click(object sender, EventArgs e)
        {
            axVitaminCtrl1.FishEyeRegionAspectRatio(Convert.ToInt32(AspectRatioWTxt.Text), Convert.ToInt32(AspectRatioHTxt.Text));
        }

        private void RecBtn_Click(object sender, EventArgs e)
        {
            if (!_bRecording){
                axVitaminCtrl1.StartMP4Conversion();
                BtnRecord.Text = "Stop";
                _bRecording = true;
            }
            else{
                axVitaminCtrl1.StopMP4Conversion();
                BtnRecord.Text = "Start";
                _bRecording = false;
            }
        }
    }
}
